#include <devices/inputevent.h>
#ifdef __GNUC__
#include <inline/exec.h>
#else
#include <clib/exec_protos.h>
#endif

void FreeIEvents(volatile struct InputEvent *events)
{
  struct InputEvent *next;
 
  while(events!=NULL)
  {
    next=events->ie_NextEvent;
    FreeMem((APTR)events,sizeof(struct InputEvent));
    events=next;
  }
}
